/*
 * MISSING LICENSING INFO
 */
package org.sod.model;

import java.util.Locale;

import com.l2jfree.gameserver.communitybbs.Manager.SettingsBBSManager;

/**
 * @author savormix
 * 
 */
public class PlayerSettings
{
	private boolean _voting;
	private boolean _waypoint;
	private boolean _messages;
	private boolean _ghostMode;
	private int _successRates;
	private Locale _locale;
	private int _localeIndex;
	
	public PlayerSettings()
	{
		this(true, true, true, true, 2, Locale.ENGLISH);
	}
	
	public PlayerSettings(boolean voting, boolean waypoint, boolean messages, boolean ghostMode, int successRates,
			Locale locale)
	{
		_voting = voting;
		_waypoint = waypoint;
		_messages = messages;
		_ghostMode = ghostMode;
		_successRates = successRates;
		setLocale(locale);
	}
	
	/** @return whether the voting windows should be shown */
	public final boolean showVoting()
	{
		return _voting;
	}
	
	/**
	 * Set vote window status.
	 * 
	 * @param voting
	 *            whether the vote windows should be shown
	 */
	public final void setShowVoting(boolean voting)
	{
		_voting = voting;
	}
	
	/** @return whether the waypoints should be shown */
	public final boolean showWaypoint()
	{
		return _waypoint;
	}
	
	/**
	 * Set waypoint status.
	 * 
	 * @param waypoint
	 *            whether the waypoints should be shown
	 */
	public final void setWaypoint(boolean waypoint)
	{
		_waypoint = waypoint;
	}
	
	/** @return whether the screen messages should be shown */
	public final boolean showMessages()
	{
		return _messages;
	}
	
	/**
	 * Set screen message status.
	 * 
	 * @param messages
	 *            whether the screen messages should be shown
	 */
	public final void setMessages(boolean messages)
	{
		_messages = messages;
	}
	
	/** @return the ghost mode status */
	public final boolean isGhostMode()
	{
		return _ghostMode;
	}
	
	/**
	 * Set ghost mode status.
	 * 
	 * @param ghostMode
	 *            whether the ghost mode should be shown
	 */
	public final void setGhostMode(boolean ghostMode)
	{
		_ghostMode = ghostMode;
	}
	
	/** @return where skill success rates are shown */
	public final int showSuccessRates()
	{
		return _successRates;
	}
	
	/**
	 * Set skill rate position.
	 * 
	 * @param position
	 *            where skill success rates should be shown
	 */
	public final void setSuccessRates(int position)
	{
		_successRates = position;
	}
	
	public Locale getLocale()
	{
		return _locale;
	}
	
	public void setLocale(Locale locale)
	{
		_locale = locale;
		_localeIndex = SettingsBBSManager.getInstance().indexOf(getLocale());
	}
	
	/**
	 * Returns the player locale's index in the global supported locale array.<BR>
	 * <BR>
	 * To be used with static/cached text that is generated by the server.
	 * 
	 * @return player locale's index
	 */
	public int getLocaleIndex()
	{
		return _localeIndex;
	}
}
